#ifndef NEIGHBOR_H
#define NEIGHBOR_H
#include "libheader.h"

class Neighbor {
public:
  Neighbor(const long motifLength, const long distance);		//constructor
  ~Neighbor();					//destructor
  
/*****************************************************************************/
/*                                                                           */
/* Pub 1 Access Attributes                                                   */
/*                                                                           */
/*****************************************************************************/
  const unsigned long* getMaskArr(long d);
  long getMaskNo(long d);
  
/*****************************************************************************/
/*                                                                           */
/* Pub 2 Algorithms                                                          */
/*                                                                           */
/*****************************************************************************/
  void createNeighborList();
                  
/*****************************************************************************/
/*                                                                           */
/* Pub 3 Parameters                                                          */
/*                                                                           */
/*****************************************************************************/  
  
private:
/*****************************************************************************/
/*                                                                           */
/* Pri 1 Algorithms                                                          */
/*                                                                           */
/*****************************************************************************/
  void createMask(const long* combinationArr, const long comArrSize
                  , unsigned long* maskArr, const unsigned long mask
                  , const long pos, long &maskNo);
                  
/*****************************************************************************/
/*                                                                           */
/* Pri 2 Parameters                                                          */
/*                                                                           */
/*****************************************************************************/
  long motifLength;
  long maxHamDist;
  unsigned long** maskList;
  long* maskNoArr;
};

#endif

