#include <iostream>
#include <fstream>
#include "tools.h"

int main(int argc, char *argv[]) {	
  const int noOfCol=3000;
  const int noOfRow=6000;
  const int tempMaxCol=6000;
  const int tempMaxRow=9000;
  const double maxBindRatio=2.0;
  char filepath[]="/student/tmp/cmleung2/motifCoef/coef3k6k.txt";
  
  FILE * pFile;
  int *dimension=new int[2];
  dimension[0]=noOfRow;
  dimension[1]=noOfCol;
  double* chooseArr=new double[tempMaxRow*tempMaxCol];
  double* coefArr=new double[noOfRow*noOfCol];
  
  //write sth to initate the array
  coefArr[0]=0;
  
  for(int i=0;i<tempMaxRow;i++){
/////////////////////////////////////////////    
    cout<<"i="<<i<<endl;
    
    for(int j=0;j<tempMaxCol;j++) {
/////////////////////////////////////////////
       if(i*tempMaxCol+j >= tempMaxRow*tempMaxCol)
         cout<<"Error i="<<i<<", j="<<j<<endl;
       
       if(i>=j)
         chooseArr[i*tempMaxCol+j]=Tools::choose(i,j);
       else
         chooseArr[i*tempMaxCol+j]=-1.0;
    }
  }
////////////////////////////////////////////
  cout<<"finish chooseArr"<<endl;
  
  double totalOutcome;
  int remindX;
  
  int mPlusOne=(int)maxBindRatio+1;
  
  for(int i=0;i<noOfRow;i++) {
/////////////////////////////////////////////    
    cout<<"i="<<i<<endl;
    
    for(int j=0;j<noOfCol;j++) {
      totalOutcome=0.0;
      for(int k=0;k<=min(i/mPlusOne, j);k++) {
        remindX=i-mPlusOne*k;
/////////////////////////////////////////////
      if(j*tempMaxCol+k >= tempMaxRow*tempMaxCol)
        cout<<"Error j="<<j<<", k="<<k<<endl;
      if((j+remindX-1)*tempMaxCol+remindX >= tempMaxRow*tempMaxCol)
        cout<<"Error j+remindX-1="<<j+remindX-1<<", remindX="<<remindX<<endl;  
        
        //(-1)^k * C(n,k) * C(j+remindX-1,remindX)
        if(i%1000==999 && j%1000==999) {
          cout<<"i="<<i<<", j="<<j<<", k="<<k<<endl;
          cout<<"  (-1)^"<<k<<" * C("<<j<<","<<k<<") * C("<<j+remindX-1<<","<<remindX<<")"<<endl;
        }
        totalOutcome+=(k%2==0?1.0:-1.0) * chooseArr[j*tempMaxCol+k] * chooseArr[(j+remindX-1)*tempMaxCol+remindX];
      }
      coefArr[i*noOfCol+j]=totalOutcome;
    }
  }
  
  pFile = fopen (filepath , "w");
  fwrite (dimension , 4 , 2 , pFile);
  fwrite (coefArr , 8 , dimension[0] * dimension[1] , pFile);
  fclose (pFile);
   
  delete chooseArr;
  delete coefArr;
}

